#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Jun 19 15:19:29 2020

@author: davidworrall
version 0.01: Fri Jun 19 15:19:29 2020. Set up intitial cv read
version 0.02: 2020 31 Define class structure for a country
version 0.03: 2020 08 06 Add SMA
version 0.04: 2020 09 18 finish marked-line plotting routines * non-printing vals <- 0
version 0.05: 2020 09 19 finish x-axis 7day divisions and labels
version 0.06: 2020 09 23 regional sort according to classification in WorldRegionsUpdated.csv
            complete plot generation and write to file
version 0.07 begin investigation of auto anomoly detection. found TAD (twitter ...)
see https://blog.twitter.com/engineering/en_us/a/2015/introducing-practical-and-robust-anomaly-detection-in-a-time-series.html


Covid19/Coronavirus global deaths
dataset:
Title:    COVID-19 Time Series Data
Author:   Shad Reynolds
URL:      https://data.world/shad/covid-19-time-series-data

based on deaths_global.csv, as reguarly updated
online comments:
@deviramanan2016•3 months ago

@shad Do you have patient level covid19 data?
@jonathangill•last month

Jonathan Gill:  @jonathangill•last month
Jonathangill021@gmail.com:  @deeworr•last month

It would be very useful to have this - even if just basic data like sex and age.
-The US data is not geographically differentiated. I'm using https://github.com/nytimes/covid-19-data/blob/master/us-counties.csv . Does anyone have a better source?

- Hi Shad. Thanks for your work on this. One point and a question, if I may:
(a) The Country field for South Korea is in the form "Korea, South" which parses as two different values. Is it possible to change it to "South Korea"? makes the code less onerous.
(b) I notice there is a (weekly) "resonance" in most sequences. Do you know if this is a result of the collation methodologies? Dee.

Google Data: https://news.google.com/covid19/map?hl=en-US&gl=US&ceid=US%3Aen

The 2020 geographic population data is from the INTERNET USAGE STATISTICS website which also has land-area:
https://www.internetworldstats.com/stats.htm
https://www.internetworldstats.com/list3.htm
World regions and old stats on reported cases (not deaths) in April 2020:\
        Africa
        Asia
        Central America
        Eastern Europe
        European Union
        Middle East
        North America
        Oceania
        South America
        The Caribbean

        AFRICA
        Eastern Africa
        Burundi - 405 cases-Aug 9/20, (5 cases April 20/20)
        Comoros - 399 cases-Aug 9/20, (no data April 20/20)
        Djibouti - 5,338 cases-Aug 9/20, (846 cases-Apr20/20)
        Eritrea - 285 cases-Aug 9/20, (39 cases-Apr20/20)
        Ethiopia - 22,253 cases-Aug 9/20, (108 cases-Apr20/20)
        Kenya - 25,837 cases-Aug 9/20, (270 cases-Apr20/20)
        Madagascar - 13,086 cases-Aug 9/20, (121 cases-Apr20/20)
        Malawi - 4,624 cases-Aug 9/20, (17 cases-Apr20/20)
        Mauritius - 344 cases-Aug 9/20, (328 cases-Apr20/20)
        Mayotte - 3,068 cases-Aug 9/20, (271 cases-Apr20/20)
        Mozambique - 2,241 cases-Aug 9/20, (39 cases-Apr20/20)
        Reunion - 681 cases-Aug 9/20, (408 cases-Apr20/20)
        Rwanda - 2,134 cases-Aug 9/20, (147 cases-Apr20/20)
        Seychelles - 126 cases-Aug 9/20, (11 cases-Apr20/20)
        Somalia - 3,227 cases-Aug 9/20, (164 cases-Apr20/20)
        Tanzania - 509 cases-Aug 9/20, (170 cases-Apr20/20)
        Uganda - 1,267 cases-Aug 9/20, (55 cases-Apr20/20)
        Zambia - 8,085 cases-Aug 9/20, (61 cases-Apr20/20)
        Zimbabwe - 4,575 cases-Aug 9/20, (25 cases-Apr20/20)

        Middle Africa
        Angola - 1,572 cases-Aug 9/20, (24 cases-Apr20/20)
        Cameroon - 18,042 cases-Aug 9/20, (1,017 cases-Apr20/20)
        CAR - 4,641 cases-Aug 9/20, (12 cases-Apr20/20)
        Chad - 942 cases-Aug 9/20, (33 cases-Apr20/20)
        Congo (Brazza) - 3,664 cases-Aug 9/20, (143 cases-Apr20/20)
        Congo, D. R. - 9,454 cases-Aug 9/20, (327 cases-Apr20/20)
        Equatorial Guinea - 4,821 cases-Aug 9/20, (79 cases-Apr20/20)
        Gabon - 7,923 cases-Aug 9/20, (109 cases-Apr20/20)
        Sao Tome and Princ - 878 cases-Aug 9/20, (4 cases-Apr20/20)

        Northern Africa
        Algeria - 34,693 cases-Aug 9/20, (2,629 cases-Apr20/20)
        Egypt - 95,314 cases-Aug 9/20, (3,144 cases-Apr20/20)
        Libya - 5,232 cases-Aug 9/20, (51 cases-Apr20/20)
        Morroco - 32,007 cases-Aug 9/20, (2,855 cases-Apr20/20)
        South Sudan - 2,463 cases-Aug 9/20, (4 cases-Apr20/20)
        Sudan - 11,894 cases-Aug 9/20, (92 cases-Apr20/20)
        Tunisia - 1,678 cases-Aug 9/20, (879 cases-Apr20/20)
        Western Sahara - 10 cases-Aug 9/20, (6 cases-Apr20/20)

        Southern Africa
        Botswana - 804 cases-Aug 9/20, (20 cases-Apr20/20)
        Eswatini - 3,128 cases-Aug 9/20, (22 cases-Apr20/20)
        Lesotho - 742 cases-Aug 9/20, (no data-Apr20/20)
        Namibia - 2,802 cases-Aug 9/20, (16 cases-Apr20/20)
        South Africa - 553,188 cases-Aug 9/20, (3,158 cases-Apr20/20)

        Western Africa
        Benin - 1,936 cases-Aug 9/20, (35 cases-Apr20/20)
        Burkina Faso - 1,175 cases-Aug 9/20, (576 cases-Apr20/20)
        Cape Verde - 2,835 cases-Aug 9/20, (61 cases-Apr20/20)
        Cote d'Ivoire - 16,620 cases-Aug 9/20, (847 cases-Apr20/20)
        Gambia - 1,090 cases-Aug 9/20, (10 cases-Apr20/20)
        Ghana - 41,003 cases-Aug 9/20, (1,042 cases-Apr20/20)
        Guinea - 7,875 cases-Aug 9/20, (579 cases-Apr20/20)
        Guinea-Bissau - 2,052 cases-Aug 9/20, (50 cases-Apr20/20)
        Liberia - 1,234 cases-Aug 9/20, (91 cases-Apr20/20)
        Mali - 2,565 cases-Aug 9/20, (224 cases-Apr20/20)
        Mauritania - 6,510 cases-Aug 9/20, (7 cases-Apr20/20)
        Niger - 1,157 cases-Aug 9/20, (648 cases-Apr20/20)
        Nigeria - 46,140 cases-Aug 9/20, (627 cases-Apr20/20)
        Saint Helena - no cases-Aug 9/20, (no cases-Apr20/20)
        Senegal - 11,175 cases-Aug 9/20, (367 cases-Apr20/20)
        Sierra Leone - 1,895 cases-Aug 9/20, (35 cases-Apr20/20)
        Togo - 1,046 cases-Aug 9/20, (84 cases-Apr20/20)

        THE AMERICAS
        North America, Latin America and the Caribbean

        The Caribbean
        Anguilla - 3 cases-Aug 9/20, (3 cases-Apr10/20)
        Antigua and Barbuda - 92 cases-Aug 9/20, (21 cases-Apr10/20)
        Aruba - 86 cases-Aug 9/20, (86 cases-Apr10/20)
        Bahamas - 878 cases-Aug 9/20, (42 cases-Apr10/20)
        Barbados - 138 cases-Aug 9/20, (67 cases-Apr10/20)
        British Virgin Islands - 9 cases-Aug 9/20, (3 cases-Apr10/20)
        Caribbean Netherlands - 13 cases-Aug 9/20, (2 cases-Apr10/20)
        Cayman Islands - 203 cases-Aug 9/20, (45 cases-Apr10/20)
        Cuba - 2,888 cases-Aug 9/20, (564 cases-Apr10/20)
        Curaçao - 31 cases-Aug 9/20, (14 cases-Apr10/20)
        Dominica - 18 cases-Aug 9/20, (16 cases-Apr10/20)
        Dominican Rep 78,778 cases-Aug 9/20, (2,620 cases-Apr10/20)
        Grenada - 24 cases-Aug 9/20, (14 cases-Apr10/20)
        Guadeloupe - 290 cases-Aug 9/20, (143 cases-Apr10/20)
        Haiti - 7,599 cases-Aug 9/20, (31 cases-Apr10/20)
        Jamaica - 1,003 cases-Aug 9/20, (63 cases-Apr10/20)
        Martinique - 336 cases-Aug 9/20, (155 cases-Apr10/20)
        Monserrat - 9 cases-Aug 9/20, (9 cases-Apr10/20)
        Puerto Rico - 22,121 cases-Aug 9/20, (1,068 cases-Apr17/20)
        Saint-Barthélemy - 9 cases-Aug 9/20, (6 cases-Apr10/20)
        St. Kitts and Nevis - 12 cases-Aug 9/20, (12 cases-Apr10/20)
        Saint Lucia - 25 cases-Aug 9/20, (15 cases-Apr10/20)
        Saint Martin - 78 cases-Aug 9/20, (32 cases-Apr10/20)
        Saint Vincent and the Grenadines - 57 cases-Aug 9/20, (12 cases-Apr10/20)
        Sint Maarten - 177 cases-Aug 9/20, (50 cases-Apr10/20)
        Trinidad and Tobago - 275 cases-Aug 9/20, (114 cases-Apr20/20)
        Turks and Caicos Islands - 170 cases-Aug 9/20, (11 cases-Apr20/20)
        Virgin Islands (US) - 528 cases-Aug 9/20, (53 cases-Apr20/20)

        Central America
        Belize - 146 cases-Aug 9/20, (18 cases-Apr18/20)
        Costa Rica - 22,802 cases-Aug 9/20, (655 cases-Apr18/20)
        El Salvador - 20,423 cases-Aug 9/20, (190 cases-Apr18/20)
        Guatemala - 56,189 cases-Aug 9/20, (235 cases-Apr18/20)
        Honduras - 46,973 cases-Aug 9/20, (457 cases-Apr18/20)
        Mexico - 475,902 cases-Aug 9/20, (3,441 cases-Apr10/20)
        Nicaragua - 3,902 cases-Aug 9/20, (7 cases-Apr10/20)
        Panama - 73,651 cases-Aug 9/20, (2,974 cases-Apr10/20)

        South America
        Argentina - 241,811 cases-Aug 9/20, (2,571 cases-Apr16/20)
        Bolivia - 89,055 cases-Aug 9/20, (441 cases-Apr16/20)
        Brazil - 3,013,369 cases-Aug 9/20, (28,912 cases-Apr16/20)
        Chile - 371,023 cases-Aug 9/20, (8,273 cases-Apr16/20)
        Colombia - 376,870 cases-Aug 9/20, (3,105 cases-Apr16/20)
        Ecuador - 93,572 cases-Aug 9/20, (8,225 cases-Apr16/20)
        Falkland Islands - 13 cases-Aug 9/20, (11 cases-Apr16/20)
        French Guiana - 8,267 cases-Aug 9/20, (86 cases-Apr16/20)
        Guyana - 554 cases-Aug 9/20, (55 cases-Apr16/20)
        Paraguay - 6,705 cases-Aug 9/20, (174 cases-Apr16/20)
        Peru - 471,012 cases-Aug 9/20, (12,491 cases-Apr16/20)
        Suriname - 2,306 cases-Aug 9/20, (10 cases-Apr16/20)
        Uruguay - 1,335 cases-Aug 9/20, (493 cases-Apr16/20)
        Venezuela - 24,961 cases-Aug 9/20, (197 cases-Apr16/20)

        Northern America
        Bermuda - 157 cases-Aug 9/20, (81 cases-Apr16/20)
        Canada - 119,221 cases-Aug 9/20, (29,929 cases-Apr16/20)
        Greenland - 14 cases-Aug 9/20, (11 cases-Apr16/20)
        Saint Pierre & Miquelon - 4 case-Aug 9/20, (1 case-Apr16/20)
        United States - 5,150,757 cases-Aug 9/20, (678,210 cases-Apr17/20)

         ASIA
        Afganistan - 37,054 cases-Aug 9/20, (993 cases-Apr19/20)
        Armenia - 40,410 cases-Aug 9/20, (1,291 cases-Apr19/20)
        Azerbaijan - 33,568 cases-Aug 9/20, (1,373 cases-Apr19/20)
        Bangladesh - 257,600 cases-Aug 9/20, (2,456 cases-Apr19/20)
        Bhutan - 108 cases-Aug 9/20, (5 cases-Apr19/20)
        Brunei Darussalam - 142 cases-Aug 9/20, (136 cases-Apr14/20)
        Cambodia - 251 cases-Aug 9/20, (122 cases-Apr14/20)
        China - 84,619-Aug 9/20, (82,249-Apr14/20)
        Georgia - 1,225 cases-Aug 9/20, (296 cases-Apr14/20)
        Hong Kong - 4,080 cases-Aug 9/20, (1,013 cases-Apr14/20)
        India - 2,158,408 cases-Aug 9/20, (10,541 cases-Apr14/20)
        Indonesia - 125,396 cases-Aug 9/20, (6,575 cases-Apr19/20)
        Japan - 45,439 cases-Aug 9/20, (7,645 cases-Apr14/20)
        Kazakhstan - 98,701 cases-Aug 9/20, (1,202 cases-Apr14/20)
        Korea, North - no data
        Korea, South - 14,598 cases-Aug 9/20, (10,564 cases-Apr14/20)
        Kyrgyzstan - 39,919 cases-Aug 9/20, (430 cases-Apr14/20)
        Laos - 20 cases-Aug 9/20, (19 cases-Apr14/20)
        Macao - 46 cases-Aug 9/20, (45 cases-Apr14/20)
        Malaysia - 9,083 cases-Aug 9/20, (4,987 cases-Apr14/20)
        Maldives - 4,898 cases-Aug 9/20, (20 cases-Apr14/20)
        Mongolia - 293 cases-Aug 9/20, (30 cases-Apr14/20)
        Myanmar - 359 cases-Aug 9/20, (63 cases-Apr14/20)
        Nepal - 22,972 cases-Aug 9/20, (16 cases-Apr14/20)
        Pakistan - 284,121 cases-Aug 9/20, (5,837 cases-Apr14/20)
        Phillipines - 129,913 cases-Aug 9/20, (6,259 cases-Apr19/20)
        Singapore - 55,104 cases-Aug 9/20, (6,588 cases-Apr19/20)
        Sri Lanka - 2,841 cases-Aug 9/20, (219 cases-Apr14/20)
        Taiwan - 480 cases-Aug 9/20, (420 cases-Apr19/20)
        Tajikistan - 7,827 cases-Aug 9/20, (no data-Apr19/20)
        Thailand - 3,351 cases-Aug 9/20, (2,613 cases-Apr14/20)
        Timor Leste (West) - 25 cases-Aug 9/20, (6 cases-Apr14/20)
        Turkmenistan - no data-Aug 9/20,
        Uzbekistan - 30,197 cases-Aug 9/20, (1,113 cases-Apr14/20)
        Vietnam - 841 cases-Aug 9/20, (266 cases-Apr14/20)

        EUROPE
        Albania - 6,275 cases-Aug 9/20, (562 cases-Apr19/20)
        Andorra - 963 cases-Aug 9/20, (704 cases-Apr19/20)
        Belarus - 68,850 cases-Aug 9/20, (4,779 cases-Apr19/20)
        Bosnia-H - 13,687 cases-Aug 9/20, (1,285 cases-Apr19/20)
        Croatia - 5,604 cases-Aug 9/20, (1,534 cases-Apr12/20)
        Faroe Islands - 303 cases-Aug 9/20, (184 cases-Apr12/20)
        Gibraltar - 197 cases-Aug 9/20, (129 cases-Apr12/20)
        Guerney and Alderney - 597 cases-Aug 9/20, (407 cases-Apr12/20)
        Iceland - 1,955 cases-Aug 9/20, (1,689 cases-Apr12/20)
        Jersey - 347 cases-Aug 9/20, (81 cases-Apr12/20)
        Kosovo - no Data, see Serbia
        Liechtenstein - 79 cases-Aug 9/20, (79 cases-Apr12/20)
        Man, Island of - 336 cases-Aug 9/20, (226 cases-Apr12/20)
        Moldova - 27,443 cases-Aug 9/20, (1,560 cases-Apr12/20)
        Monaco - 131 cases-Aug 9/20, (92 cases-Apr12/20)
        Montenegro - 3,588 cases-Aug 9/20, (263 cases-Apr12/20)
        North Macedonia - 11,754 cases-Aug 9/20, (760 cases-Apr12/20)
        Norway - 9,599 cases-Aug 9/20, (6,409 cases-Apr12/20)
        Russia - 887,536 cases-Aug 9/20, (13,584 cases-Apr12/20)
        San Marino - 699 cases-Aug 9/20, (356 cases-Apr12/20)
        Serbia - 27,863 cases-Aug 9/20, (3,380 cases-Apr12/20)
        Svalbard and Jan Mayen Islands - no Data
        Switzerland - 36,603 cases-Aug 9/20, (25,107 cases-Apr12/20)
        Turkey - 239,622 cases-Aug 9/20, (56,956 cases-Apr12/20)
        Ukraine - 80,949 cases-Aug 9/20, (2,511 cases-Apr12/20)
        UK - 309,763 cases-Aug 9/20, (103,093 cases-Apr17/20)
        Vatican City - 12 cases-Aug 9/20, (8 cases-Apr12/20)

        EUROPEAN UNION
        Austria - 22,033 cases-Aug 9/20, (14,476 cases-Apr17/20)
        Belgium - 73,401 cases-Aug 9/20, (34,809 cases-Apr17/20)
        Bulgaria - 13,343 cases-Aug 9/20, (825 cases-Apr17/20)
        Cyprus - 1,233 cases-Aug 9/20, (735 cases-Apr17/20)
        Czechia - 18,235 cases-Aug 9/20, (6,433 cases-Apr17/20)
        Denmark - 14,442 cases-Aug 9/20, (6,879 cases-Apr17/20)
        Estonia - 2,152 cases-Aug 9/20, (1,434 cases-Apr17/20)
        Finland - 7,584 cases-Aug 9/20, (3,369 cases-Apr17/20)
        France - 197,921 cases-Aug 9/20, (165,027 cases-Apr17/20)
        Germany - 216,896 cases-Aug 9/20, (137,698 cases-Apr17/20)
        Greece - 5,421 cases-Aug 9/20, (2,207 cases-Apr17/20)
        Hungary - 4,696 cases-Aug 9/20, (1,763 cases-Apr17/20)
        Ireland - 26,644 cases-Aug 9/20, (13,271 cases-Apr17/20)
        Italy - 250,103 cases-Aug 9/20, (168,941 cases-Apr17/20)
        Latvia - 1,290 cases-Aug 9/20, (675 cases-Apr17/20)
        Lithuania - 2,252 cases-Aug 9/20, (1,128 cases-Apr17/20)
        Luxembourg - 7,169 cases-Aug 9/20, (3,444 cases-Apr17/20)
        Malta - 1,089 cases-Aug 9/20, (412 cases-Apr17/20)
        Netherlands - 57,987 cases-Aug 9/20, (29,214 cases-Apr17/20)
        Poland - 51,791 cases-Aug 9/20, (7,918 cases-Apr17/20)
        Portugal - 52,537 cases-Aug 9/20, (18,841 cases-Apr17/20)
        Romania - 61,768 cases-Aug 9/20, (7,707 cases-Apr17/20)
        Slovakia - 2,596 cases-Aug 9/20, (977 cases-Apr17/20)
        Slovenia - 2,247 cases-Aug 9/20, (1,268 cases-Apr17/20)
        Spain - 361,442 cases-Aug 9/20, (184,948 cases-Apr17/20)
        Sweden - 82,323 cases-Aug 9/20, (12,540 cases-Apr17/20)

        MIDDLE EAST
        Bahrain - 43,629 cases-Aug 9/20, (1,773 cases-Apr19/20)
        Iran - 326,712 cases-Aug 9/20, (82,211 cases-Apr19/20)
        Iraq - 147,389 cases-Aug 9/20, (1,513 cases-Apr19/20)
        Israel - 82,515 cases-Aug 9/20, (13,362 cases-Apr19/20)
        Jordan - 1,246 cases-Aug 9/20, (413 cases-Apr19/20)
        Kuwait - 71,199 cases-Aug 9/20, (1,915 cases-Apr19/20)
        Lebanon - 6,223 cases-Aug 9/20, (673 cases-Apr19/20)
        Oman - 81,580 cases-Aug 9/20, (1,266 cases-Apr19/20)
        Palestine - 14,205 cases-Aug 9/20, (431 cases-Apr19/20)
        Qatar - 112,947 cases-Aug 9/20, (5,448 cases-Apr19/20)
        Saudi Arabia - 287,262 cases-Aug 9/20, (8,274 cases-Apr19/20)
        Syria - 1,125 cases-Aug 9/20, (38 cases-Apr19/20)
        UAE - 62,525 cases-Aug 9/20, (6,781 cases-Apr19/20)
        Yemen - 1,797 case-Aug 9/20, (1 case-Apr19/20)

        OCEANIA
        Australia - 20,698 cases-Aug 9/20, (6,497 cases-Apr17/20)
        Fiji - 27 cases-Aug 9/20, (17 cases-Apr17/20)
        French Polynesia - 69 cases-Aug 9/20, (55 cases-Apr17/20)
        Guam (USA) - 411 cases-Aug 9/20, (135 cases-Apr17/20)
        Kiribati - no data
        Marshall Islands - no data
        Micronesia - no data
        New Caledonia - 23 cases-Aug 9/20, (18 cases-Apr17/20)
        New Zealand - 1,569 cases-Aug 9/20, (1,409 cases-Apr17/20)
        Northern Mariana Islands (USA) - 48 cases-Aug 9/20, (13 cases-Apr17/20)
        Samoa - no data
        Samoa, American - no data
        Solomon, Islands - no data
        Tonga - no data
        Vanuatu - no data
"""
# ====================IMPORT PROVINCE DATA AND STORE IN A DICT ===============#

colLabelRow  = 0        # Some columnanmes to enhance readability
stateCol     = 0
countryCol   = 1
LatCol       = 2
LongCol      = 3
DateBeginCol = 4

import csv
directory="/Users/davidworrall/Documents/RESEARCH/COVID-19/dataSets/"
directory="/volumes/DRWORANGE32/COVID-19/dataSets/"
imageDirectory = "/volumes/DRWORANGE32/COVID-19/graphImages/deaths_global/"
fname= "deaths_global.csv" # "us-counties20200516.csv"

directory="/Users/davidworrall/Documents/RESEARCH/COVID-19/dataSets/"
directory="/volumes/DRWORANGE32/COVID-19/dataSets/"
imageDirectory = "/volumes/DRWORANGE32/COVID-19/graphImages/deaths_global/"

#with open('/Users/davidworrall/Documents/CCC/TEACHING/TeachingResources_DSon/LiteracyRatesGlobalLongRun.csv', newline='') as csvfile:
# =========== PULL THE JOHNS Hopkins DB  FILE =================================
with open(directory+fname, newline='') as csvfile:
    ipdata = csv.reader(csvfile, delimiter=',', quotechar='"')
    deathsDB = []
     # to avoid commas and standardise across DBs. NB OSofT is "deaths_global.csv"
    for row in ipdata:                                              # bespoke province namefixes
        if row [countryCol] == "Korea, South": row [countryCol] = 'South Korea'
        if row [stateCol]   == "Bonaire, Sint Eustatius and Saba": row [stateCol] = 'Bonaire Sint Eustatius and Saba'
        if row [countryCol] == 'Taiwan*': row [stateCol] = 'Taiwan'
        if row [countryCol] == 'Congo (Kinshasa)': row [countryCol] = 'Congo-Kinshasa (DR)' ;row [stateCol] = ''
        if row [countryCol] == 'Congo (Brazzaville)': row [countryCol] = 'Congo-Brazzaville' ; row [stateCol] = ''
        if row [countryCol] == 'Holy See': row [countryCol] = 'Vatican'
        if row [countryCol] == 'Sint': row [countryCol] = 'Sint Maarten'
        if row [countryCol] == 'Pierre': row [countryCol] = 'Sant Pierre and Miquelon'
        if row [countryCol] == 'Terres': row [countryCol] = 'Terres Australes'
        if row [countryCol] == 'Smaller': row [countryCol] = 'Smaller Territories (BR)'
        if row [countryCol] == 'St Martin': row [countryCol] = 'Saint Martin'
        if row [countryCol] == "Cote d'Ivoire": row [countryCol] = 'Cote dIvoire'

        deathsDB += [[','.join(row)]]
for indx in range (1,len(deathsDB)):
    deathsDB[indx] = deathsDB[indx][0].split(',')                   # each row of the DB is indexed sequentially as per the original file
# convert death data to ints
    deathsDB[indx] [LatCol]    = float (deathsDB[indx] [LatCol])    # convert Latitude string to float
    deathsDB[indx] [LongCol]   = float (deathsDB[indx] [LongCol])   # convert Longditude string to float
    for deathNr in range (LongCol+1, len (deathsDB[indx])):         # convert the rest (death numbers) to ints
        deathsDB[indx][deathNr] = int (deathsDB[indx][deathNr])

deathsDB[colLabelRow] = deathsDB[colLabelRow][0].split(',')         # The column title texts/\
#           sunday      monday      tuesday   (wed = 1/22/20, the first date in the database, pre pad is used to startCharts on a Sun
datePad = ['1/19/20','1/20/20', '1/21/20']                          # 1/22/20 (the first date in the DB) is a Wed, so pre pad for a Sunday start
dataPad = [0, 0, 0]                                                 # insert len ( datePad days of 0 data)
columnLabels = deathsDB[0]
dateSpacer = "."                                                    # a list of the column headings (dates etc)
#print ("============\nColumn Labels\n============\n", columnLabels)

dates = datePad + columnLabels[4:]                                  # Sunday-padded dates   #print (dates)
#print (dates)

deathsDB = deathsDB[1:]                                             # drop the column headings

monthDict= {'01':'Jan ', '02':'Feb ', '03':'Mar ', '04':'Apr ','05':'May ', '06':'June',
            '07':'July', '08':'Aug ', '09':'Sep ', '10':'Oct ','11':'Nov ','12':'Dec ' }
def mmddyyyyy2yyyymmdd(spacer="" , alphaMonth = False):
    """ converts US dates in DB (mm/dd/yy) to international (yyyySmmSdd)"""
    for indx in range (len(dates)):
        #print (dates [indx] , end= " ")                     # dates start at col 4
        tmp = dates[indx].split('/')                         # [mm, dd, yy] as per the dataset
        year    = '20'+tmp[2]
        month   = ('0' +tmp[0])[-2:]
        day     = ('0' +tmp[1])[-2:]
        if alphaMonth:
            month = monthDict[month]
            dates[indx]= year + month + day #[yyyyJan.dd]. S = spacer
        else:
            dates[indx]= year + dateSpacer + month + day #[yyyyJan.dd]. S = spacer


mmddyyyyy2yyyymmdd(".", alphaMonth=True )  # cseparate date components with a ","  # print (dates)

#deathsDB = deathsDB[1:]                                             # drop the column headings
#print ("============\nColumn Labels\n============\n", dates)

countriesList = []              # collate all multiple-province country provinces into a single country entry
for province in deathsDB:       # make a lit of all countries with provinces
    if province[0] != '':
        if province[1] not in countriesList:
            countriesList += [province[1]]

for country in countriesList:                                                # compute the running sums of contries in provinces
    runningDeathsSum = ['',country,'','']+ [0] * (len (columnLabels) - 4)    # we just want the death data clugey
    for province in deathsDB:                                                # find each province for that country
        if province [1] == country:
            for indx in range (4, len (runningDeathsSum)):
                runningDeathsSum [indx] = runningDeathsSum [indx] + province [indx]
#    print (runningDeathsSum)
    deathsDB += [runningDeathsSum]                                           #   add new country summation to the deathsDB

# if no province, make province == country
for prov in deathsDB:
    if prov[stateCol]=="":
        prov[stateCol] = prov [countryCol]


provinceDeathsDict = {}                 # a dict to hold all country, province and summed-province data
for province in deathsDB:               # Collates all provinces into a single dictionary entry
    if province[0] == "":
        provinceDeathsDict [province[1]]  = province        # there is no province, the dict key is country
    else:
        provinceDeathsDict [province[0]]  = province        # there is more than on province so use the dick key is the province

def printAllProvinces():
    kees = sorted (provinceDeathsDict.keys())               # alpha sort for pretty print
    for keeNr in range (len (kees)):
        print (kees[keeNr], end="\t\t")
#        if keeNr % 3 == 0: print()

# =========== PULL THE Country Population Data DB FILE =================================
#directory="/Users/davidworrall/Documents/RESEARCH/COVID-19/dataSets/"
#directory="/volumes/DRWORANGE32/COVID-19/dataSets/"
#with open('/Users/davidworrall/Documents/CCC/TEACHING/TeachingResources_DSon/LiteracyRatesGlobalLongRun.csv', newline='') as csvfile:

colLabelRow     = 0
regionNameCol   = 0
countryNameCol  = 1
countrySymbolCol= 2
areaCol         = 3
populationCol   = 4
densityCol      = 5              # used to calculate the density - easily changed

fname2 = "countryPopulationData.csv"   # "for the population and geographic data
#  fields are:
#    0            1        2      3             4       5(unused)      6(unused) 7(blank)   8unused)
#[RegionName,CountryName,Symbol,Size(sq.km.),Population,InetUsers,InetPenetration,Density,DataDate]

with open(directory+fname2, newline='') as csvfile:
    ipdata = csv.reader(csvfile, delimiter=',', quotechar='"')
    populationDB = []
    for row in ipdata:                                              # bespoke province namefixes
        if row [countryNameCol] == "Korea, South": row [countryNameCol] = 'South Korea'
        if row [countryNameCol] == "Korea, North": row [countryNameCol] = 'North Korea'
        if row [countryNameCol] == "Bonaire, Sint Eustatius and Saba": row [countryNameCol] = 'Bonaire Sint Eustatius and Saba'
        if row [countryNameCol] == 'Taiwan*': row [countryNameCol] = 'Taiwan'
        if row [countryNameCol] == "Cote d'Ivoire": row [countryNameCol] = 'Cote dIvoire'

        if row [countryNameCol] == 'Congo (Kinshasa)': row [countryNameCol] = 'Congo-Kinshasa (DR)'
        if row [countryNameCol] == 'Congo (Brazzaville)': row [countryNameCol] = 'Congo-Brazzaville'
        if row [countryNameCol] == 'Holy See': row [countryNameCol] = 'Vatican'
        if row [countryNameCol] == 'Sint': row [countryNameCol] = 'Sint Maarten'
        if row [countryNameCol] == 'Pierre': row [countryNameCol] = 'Sant Pierre and Miquelon'
        if row [countryNameCol] == 'Terres': row [countryNameCol] = 'Terres Australes'
        if row [countryNameCol] == 'Smaller': row [countryNameCol] = 'Smaller Territories (BR)'
        if row [countryNameCol] == 'St Martin': row [countryNameCol] = 'Saint Martin'

        populationDB += [[','.join(row)]]
for indx in range (1,len(populationDB)):
    populationDB[indx] = populationDB[indx][0].split(',')                      # each row of the DB is indexed sequentially as per the original file
    try:    populationDB[indx][areaCol] = float (populationDB[indx][areaCol])  # try convert from str
    except: populationDB[indx][areaCol] = 0.0                                  # or set to 0.0
    try:    populationDB[indx][populationCol] = float(populationDB[indx][populationCol]) # try convert from str or set to 0.0
    except: populationDB[indx][populationCol] = 0.0
#    if populationDB[indx][populationCol] != 0.0:                               # no area so not recorded
#        populationDB[indx][densityCol] = populationDB[indx][areaCol] / populationDB[indx][populationCol]

populationDB[colLabelRow] = populationDB[colLabelRow][0].split(',')            # The column title texts/\
# print (populationDB[colLabelRow])


# check which countries in the populationDB are or are not in the provinceDeathsDict.keys())
deathProvinceNames = sorted (provinceDeathsDict.keys())
inBothDB = []
inJustDeathDB = []
inJustPopulationDB = []
for provinceNr in range (2, len (populationDB)):
#    print (populationDB[provinceNr][countryNameCol])
    if populationDB[provinceNr][countryNameCol] in deathProvinceNames:
        inBothDB += [populationDB[provinceNr][countryNameCol]]
    else:
        inJustDeathDB += [populationDB[provinceNr][countryNameCol]]

# Now make a demographicDB data for those in inBothDB
demographicDict = {}
for entry in populationDB:
    if entry[countryNameCol] in inBothDB:
         demographicDict[entry[countryNameCol]] = entry[:5] # regionName,countryName,countrySymbol,area,pop


    
"""provinceDensityDict = {}                                 # a dict to hold all country, province and summed-province population data
for province in populationDB:                           # Collates all provinces into a single dictionary entry
    if provinceDensityDict[0] == "":
        provinceDeathsDict [province[1]]  = province        # there is no province, the dict key is country
    else:
        provinceDeathsDict [province[0]]  = province        # there is more than one province so use the dict key as the province

def printAllProvinces():
    kees = sorted (provinceDeathsDict.keys())               # alpha sort for pretty print
    for keeNr in range (len (kees)):
        print (kees[keeNr], end="\t\t")
#        if keeNr % 3 == 0: print()

"""


# ====================DEFINE DEATH CLASS FOR GLOBAL COUNTRIES/STATES?PROVINCES#

class CountryDeaths():    # define a class for handling Covid-19 death data for a country
    def __init__(self, countryName):
        #Initialize data attributes.
        self.countryName        = countryName
        self.countryExists      = False
        self.printData          = False                 # used to filter death data when using print (instance)
        self.provinceName       = ""                    # filled from deahDB  by __init__()
        self.region             = ""                    # filled from populationDB  by __init__()
        self.latitude           = countriesList[LatCol]
        self.longitude          = countriesList[LatCol]
        if self.countryName in demographicDict.keys():
            self.countryCode        = demographicDict [self.countryName][countrySymbolCol]
            self.area               = demographicDict [self.countryName][areaCol]
            self.population         = demographicDict [self.countryName][populationCol]
            if self.population > 0:
                self.populationDensity  = self.population/self.area
                                    #sun     mon       tuea          wed
        self.prePadDates        = ['1/19/20','1/20/20', '1/21/20'] # 1/22/20 = first data date. prepad for a Sunday start
        self.prePadData         = [0] * len (self.prePadDates)     # insert len ( self.prePadDates days of data = 0)
        self.cumulativeDeaths   = self.prePadData                  # start the list by prepadding
        self.deathIncrements    = []  #NB clculaed from self.cumulativeDeaths, so no need to prePad
        self.ascending          = []
        self.sortedIndices      = []                    # indices of increments in ascending order
        self.NrDataPoints       = 0                     # Needed many time so no need to keep calculating it
        self.mean               = 0                     # Mean nr of Deaths / day calculated in the Stats method
        self.max                = 0                     # Max Nr of Deaths in any one day calculated in the Stats method
        self.simpleMovingAveragePeriod = 0              # calculated in the Stats method
        self.SMAdata            = []

        if self.countryName not in provinceDeathsDict.keys():
            self.countryExists = False
            print (self.countryName + " does not exist in the Database.\nIt contains data for the following countries:")
 #           kees = sorted (provinceDeathsDict.keys())    # alpha sort for 'pretty' print
 #           for keeNr in range (len (kees)):
#                print (kees[keeNr], end="\t")
 #               if keeNr % 3 == 0: print()               # throw a CR
            return (None)
        else:
            self.countryExists = True
#            print("*********", provinceDeathsDict[self.countryName])
#            print
            self.provinceName   = provinceDeathsDict[countryName][0] #countriesList[self.countryName][0]
            self.latitude       = provinceDeathsDict[countryName][2] # countriesList[LatCol]
            self.longitude      = provinceDeathsDict[countryName][3] # countriesList[LongCol]
            self.area           = None
            self.population     = None
            self.cumulativeDeaths = self.prePadData + provinceDeathsDict[countryName][4:]
            # block the printing of values <=0
            for indx in range (len(self.cumulativeDeaths)):
                if self.cumulativeDeaths[indx] <= 0:
                    self.cumulativeDeaths[indx] = 0 # float ('nan')     # nan = not-a-number            #
            self.deathIncrements = [0]* len (self.cumulativeDeaths)
            for dayNr in range (1,len (self.cumulativeDeaths)):
                self.deathIncrements[dayNr] = self.cumulativeDeaths[dayNr]-self.cumulativeDeaths[dayNr-1]
                if self.deathIncrements[dayNr] <0:                      # indicates data error
                    if self.printData:
                        print ("DATA ERROR:",self.countryName , end="\t")
#                      print ("DATA ERROR:Some dead rose again in ",self.countryName , "on", :", end="/t")
                        print (dayNr,":",dates[dayNr], "\t", self.cumulativeDeaths[dayNr-1],"\t",self.cumulativeDeaths[dayNr],"\tdiff :", self.deathIncrements[dayNr-1],self.deathIncrements[dayNr])

                    self.deathIncrements[dayNr] = 0  # just zero it : #  ============ ERROR CORRECTION==============
            self.generateStats()
            #  ============== NBNBNBNBNBNBN
            self.zeros2NANs()                       # disable printing of 0's
            #print (self.deathIncrements)
            if self.provinceName == "":
                self.provinceName = self.countryName # the 'province' is the country
            self.NrDataPoints = len (self.deathIncrements)
            self.generateStats()
#            countriesInConsiderationList += [self.countryName]

    def __str__(self):
#        # Defines what to do when the default python help() function is called on an instance
        if self.countryExists == True:
            print ('#' * 30)
            print ('Country:',                      self.countryName, end = ' ')
            print ('(Code: ', self.countryCode, ')')
#            print ('#' * 30)
            if self.provinceName !='' or (self.province == self.countryName) :
                print ('Province:\t' ,              self.provinceName)
            print ('Latitude:\t' ,                  self.latitude)
            print ('Longitude:\t' ,                 self.longitude)
#            print ('Population:\t' , self.population)
            print ("Total Number of Deaths:\t",     self.cumulativeDeaths[-1])
            print ('Mean of new deaths/day:\t',     self.mean)
            print ('Max Nr of deaths/day:\t',       self.max )
            if self.countryName in demographicDict.keys():
                self.area               = demographicDict [self.countryName][areaCol]
                self.population         = demographicDict [self.countryName][populationCol]
                print ("CountryCode:\t",            self.countryCode)
                print ('Area (sq kms):\t',          self.area)
                print ('Population:\t' ,            self.population)
                if self.population > 0:
                    self.populationDensity  =       self.population/self.area
                    print ('Population Density:\t', self.populationDensity)
                else: print ("No demographic data available")
            if not self.printData:
                print ("Switch self.printData on for more complete details of "+self.countryName+ 'statistics.')
            if self.printData:
                print (self.countryName+': Cumulative Deaths:\n',       self.cumulativeDeaths)
                print (self.countryName+': Death Increments:\n',        self.deathIncrements)
                print (self.countryName+': Sorted deathIncrements:\n',  self.ascending)
        return ("")

    def generateStats (self):
        # generates some stats of the death
        from statistics import mean
        self.mean       = self.nanMean (self.deathIncrements) #; print ('Daily deaths, mean   :', self.mean)
        self.max        = max (self.deathIncrements) #; print ('Daily deaths, maxVal :', self.max )
        self.ascending  = sorted(self.deathIncrements)
#        sorted(range(len(vals)), key=vals.__getitem__)
        kee = self.deathIncrements.__getitem__
        deathIncrementIndices = range(len(self.deathIncrements))  # 0,1, 2, ... len()
        self.sortedIndices = sorted(deathIncrementIndices, key=kee)
#        sorted(range(len(vals)), key=vals.__getitem__)

    def SMA (self, NrPeriods):
        #Computes a Simple Moving Average of self.deathIncrements over NrPeriods
        self.simpleMovingAveragePeriod = NrPeriods
        self.SMAdata = []
        lastDataPointIndex = len (self.deathIncrements)
        if lastDataPointIndex <  self.simpleMovingAveragePeriod:
            print ("Averaging period too long." +
                   "Longest period is: ", lastDataPointIndex-self.simpleMovingAveragePeriod)
            return(None)
        index = 0
        while index < self.NrDataPoints:
            thisWindow = self.deathIncrements[index: index+ self.simpleMovingAveragePeriod]
            windowAverage = sum(thisWindow) / self.simpleMovingAveragePeriod
#            print (thisWindow, windowAverage )
            self.SMAdata += [windowAverage]  # .append (windowAverage)
            index += 1

    def nanMean (self, listy):
        #Computes the mean of a list containing float ('nan') values
        nrItems = len (listy)
        sumItems = 0
        for item in listy:
            try:
                sumItems += item
            except:
                pass     # faster than adding 0
        print ("sum + len + mean", sumItems, len (listy), sumItems/len(listy))
        return sumItems/len (listy)
               

    def zeros2NANs (self):
        # replace all zeros with float ('nan') [Not A Number] to suppress printing of all 0 values
        nrDays = len(self.deathIncrements)
        for indx in range (1, nrDays): # don't use the first one
            if self.deathIncrements[indx] > (200 + self.deathIncrements[indx-1]):  # attempt at filtering outliers
                pass
            # print (self.deathIncrements[indx-1], self.deathIncrements[indx])
            #self.deathIncrements[indx] = 0 # self.deathIncrements[indx-1]
        for indx in range (nrDays):  # leave last value to set manually
            if self.deathIncrements[indx] <= 0:       # zero -ve increments:resurrection currently not available :-)
               self.deathIncrements[indx] = float('nan')
        self.deathIncrements[0]=0               # Kludge: force a printable val so graph will start at the 0th index
        if not (self.deathIncrements [-1] > 0):
            self.deathIncrements += [0]         # Kludge: force a printable val so graph will end  at the 0th index

# ===================  END OF CLASS DEFINITION ====================================
# ===================  covid19plotting.py - with matplotlib ====================================

import matplotlib.pyplot as plt
# =================================
covidInstanceDict = {}   # used to  store country instances for plotting etc
def graphCountries(listOfCountryNames,graphName, nrFigureCols = 1, directToFile=False):
    " draws a graph of a list of country instances. If directToFile=True, closes the plot display after saving an image file"
    title = 'Daily Covid-19 Reported Deaths: '+graphName+'\n'+ dates[0][4:]+ " " + dates[0][:4] + '—' +dates[-1][4:]+ " " + dates[-1][:4]
    plt.figure (num = 1, figsize = (18.0,12.0))
    plt.title (title, fontsize=14)
    plt.ylabel("Number of Confirmed Deaths Reported", fontsize=9)
    plt.xlabel("Daily Dates (Sundays labeled)", fontsize=9)
    plt.grid(axis='both', which='both', color='grey', linestyle='-', linewidth=0.15)  # was 0.2
    plt.xticks (rotation = 45) #'vertical'
    xlabels = dates #datePad + columnLabels[4:]  # the dates. The first is Wednesday, Jan 22. Need to add 3 days to the beginning
    xmarkers = list (range(0,len(xlabels)+7, 7)) # one per week
    xlabels2 = [xlabels[datey][-6:] for datey in range(0,len(xlabels), 7)]  # omot year- take just month and day
    xlabels2 = [xlabels[datey][-6:] for datey in range(0,len(xlabels), 1)]  # omot year- take just month and day
    plt.xticks(xmarkers, xlabels2, fontsize=10)

    for country in listOfCountryNames:
          instanceString = "covidInstanceDict['"+country+"'] = CountryDeaths('"+country+"')"
#          print ("==================")
          exec(instanceString)                  # create the instance
#          print("attempt to execute NANs:", instanceString+'.zeros2NANs()')

          dgStr1 = "plt.plot(covidInstanceDict['"
          dgStr2 = "'].deathIncrements, label='"
          dgStr3 ="', marker='.', linewidth='0.35')"
          dgStr3 ="', marker='.', linewidth='0.0')"
          dataGraphString = dgStr1 +country+ dgStr2 +country+ dgStr3
#          print ('datagraphString:', dataGraphString)
          exec(dataGraphString)                         #  store a  created country instance in the country dictionaty

    plt.legend(title='Country/Region', loc = 'upper left', ncol=nrFigureCols, shadow = False)  # wish list + transparent=True
    datey = dates[-1].replace(dateSpacer,"").replace(" ","")    # take out the separator for the filename
    plt.savefig(imageDirectory+graphName+'_covid19_'+datey+'.png', format = 'png',
                orientation='landscape', transparent=False )
    plt.show()
    if directToFile: #  close the Figure #  default is false -- SWITCH TO TRUE TO eact
#        pass
        plt.close()


              # EasternEurope,'Eastern Europe'
                                 # Americas, 'The Americas'
AmericaCentral1     = ['Mexico', 'Brazil', 'Guatemala', 'Bolivia',]

AmericaCentral2      = ['Belize', 'Cuba', 'Honduras',  'Panama', 'Nicaragua']
AmericaNorth        = ['Canada', 'Alberta','British Columbia', 'Diamond Princess', 'Grand Princess', 'Manitoba',
                       'New Brunswick', 'Newfoundland and Labrador', 'Northwest Territories', 'Nova Scotia',
                       'Ontario', 'Prince Edward Island', 'Quebec', 'Saskatchewan', 'US']
AmericaSouth        = ['Venezuela', 'Peru', 'Argentina', 'Uruguay', 'Falkland Islands (Malvinas)', 'French Guiana',
                       'Guyana','Paraguay']

AfricaNorthern1     = ['Senegal' ,'Mauritania', 'Western Sahara', 'Mali', 'Niger', 
                      'Libya','Chad',  'Eritrea','Somalia','Djibouti', 'South Sudan', 'Suriname']
AfricaNorthern2     = ['Egypt', 'Algeria', 'Morocco','Sudan',]
#AfricaCentral       = ['Ghana', 'Burkina Faso', 'Nigeria', 'Ga'zbon', 'Equatorial Guinea', 'Congo',
#                       'Zambia', 'Tanzania', 'Malawi', "Cote dIvoire", 'Togo', 'Benin', 'Burkina Faso']
AfricaCentral1       = ['Ghana',  'Zambia', 'Nigeria','Malawi',]
AfricaCentral2       = ['Burkina Faso', 'Tanzania',  'Togo', 'Benin', 'Burkina Faso', 'Cote dIvoire']  # 'Cote dIvoire', 
AfricaWest          = ['Guinea', 'Guinea-Bissau','Gambia', 'Sierra Leone', 'Liberia',  'Sao Tome and Principe']
AfricaEastern       = ['Mayotte', 'Mauritius',  'Mozambique', 'Rwanda',  'Seychelles', 'Uganda'] #'Eastern Africa',
AfricaSouthern1      = ['Namibia', 'Botswana', 'Angola','Zimbabwe','Madagascar', 'Kenya', 'Lesotho' ]
AfricaSouthern2      = ['South Africa' ]

Asia                = ['China', 'Anhui', 'Beijing', 'Chongqing', 'Fujian', 'Gansu', 'Guangdong', 'Guangxi',
                       'Guizhou', 'Hainan', 'Hebei', 'Heilongjiang', 'Henan', 'Hong Kong', 'Hubei',
                       'Hunan', 'Inner Mongolia', 'Mongolia', 'Jiangsu', 'Jiangxi', 'Jilin', 'Liaoning', 'Macau',
                       'Ningxia', 'Qinghai', 'Shaanxi', 'Shandong', 'Shanghai', 'Shanxi', 'Sichuan',
                       'Tianjin', 'Tibet', 'Xinjiang', 'Yunnan', 'Zhejiang', 'Turks and Caicos Islands',
                       'South Korea', 'Japan','Taiwan', 'Nepal', 'Burma', 'Bhutan', 'Maldives']  # NB no North Korea
AsiaNoChina         = [ 'Turks and Caicos Islands','South Korea', 'Japan','Taiwan', 'Nepal', 'Burma', 'Bhutan', 'Maldives']  # NB no North Korea
AsiaSouth           = ['Bangladesh', 'India','Pakistan', 'Sri Lanka' ]  #  'Myanmar', 
AsiaSouth1           = ['Laos', 'Thailand', 'Vietnam', 'Cambodia', 'Mongolia', 'Tajikistan']
AsiaSouth2           = ['Pakistan', 'India', 'Bangladesh', 'Sri Lanka', 'Laos', 'Thailand', 'Vietnam', 'Cambodia', 'Mongolia', 'Tajikistan' ] #'Myanmar', 
AsiaSouth3           = ['India',]
AsiaSouthEast       = ['Philippines','Malaysia','Singapore','Indonesia', 'Papua New Guinea','Timor-Leste']

Canada1              = ['Alberta', 'Northwest Territories','British Columbia',  'Manitoba', 'New Brunswick', 'Newfoundland and Labrador',
                        'Nova Scotia', 'Prince Edward Island', 'Saskatchewan'] #plus 'Canada' 'Diamond Princess', 'Grand Princess',
Canada2              = ['Ontario', 'Quebec' ] #plus 'Canada' 'Diamond Princess', 'Grand Princess',

Carribean1           = ['Anguilla', 'Antigua and Barbuda', 'Aruba', 'Bahamas', 'Barbados', 'Bermuda',
                        'Cayman Islands', 'Grenada', 'Guadeloupe', 'Haiti',]

Carribean2           = ['Jamaica', 'Martinique', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Pierre and Miquelon',
                        'Saint Vincent and the Grenadines', 'Sint Maarten', 'Trinidad and Tobago', 'Tunisia']
Carribean3           = ['Anguilla', 'Antigua and Barbuda', 'Aruba', 'Bahamas', 'Barbados', 'Bermuda',
                        'Cayman Islands', 'Grenada', 'Guadeloupe', 'Haiti', 'Jamaica', 'Martinique', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Pierre and Miquelon',
                        'Saint Vincent and the Grenadines', 'Sint Maarten', 'Trinidad and Tobago', 'Tunisia']

ChineseProvinces1    = ['Anhui', 'Beijing', 'Chongqing', 'Fujian', 'Gansu', 'Guangdong', 'Guangxi', 'Guizhou']
ChineseProvinces2    = ['Hainan', 'Hebei', 'Heilongjiang', 'Henan', 'Hong Kong', 'Hubei', 'Hunan', 'Inner Mongolia', 'Mongolia']
ChineseProvinces3    = ['Jiangsu', 'Jiangxi', 'Jilin', 'Liaoning', 'Macau', 'Ningxia', 'Qinghai', 'Shaanxi', ]
ChineseProvinces4    = ['Shandong', 'Shanghai', 'Shanxi', 'Sichuan', 'Tianjin', 'Tibet', 'Xinjiang', 'Yunnan', 'Zhejiang']

EuropeNorthEastern  = ['Belarus', 'Estonia', 'Iceland','Kosovo', 'Latvia', 'Lithuania', 'Poland' ,
                        'Russia', 'Kyrgyzstan', 'Slovenia']
EuropeCentralEastern1 = ['Austria', 'Bosnia and Herzegovina', 'Czechia','Hungary', 'Moldova','Romania',
                        'Serbia', 'Slovakia', 'Ukraine' ]
#EuropeCentralEastern1 = ['Austria', 'Bosnia and Herzegovina', 'Czechia','Hungary', 'Moldova','Romania',
#                        'Serbia', 'Slovakia', 'Ukraine' ]
EuropeNorthWestern1  = [ 'Denmark', 'Finland', 'Iceland', 'Norway', 'Sweden']
EuropeNorthWestern2  = [ 'Denmark', 'Finland', 'Iceland', 'Norway']
EuropeNorthWestern3  = [ 'Sweden']

EuropeSouthEastern  = ['Albania', 'Armenia', 'Azerbaijan', 'Georgia']
EuropeSouthWestern1  = ['Andorra', 'Bulgaria',  'Greece', 'Gibraltar', 'Ireland', 'Isle of Man',
                        'Liechtenstein', 'Luxembourg','Malta', 'Monaco', 'Montenegro',  'Netherlands',
                        'North Macedonia', 'Portugal', 'San Marino',  'Switzerland',  ]
EuropeSouthWestern2  = ['Andorra',  'Greece', 'Gibraltar', 'Ireland', 'Isle of Man',
                        'Liechtenstein', 'Luxembourg','Malta', 'Monaco', 'Montenegro',  'Netherlands',
                        'North Macedonia', 'Portugal', 'San Marino',  'Switzerland',  ]
EuropeSouthWestern3 = [ 'United Kingdom', 'France','Germany', 'Italy', 'Spain', 'Belgium' ]

MiddleEast1         = ['Bahrain', 'Yemen', 'Lebanon', 'Oman', 'Jordan',  'United Arab Emirates']
MiddleEast2         = ['Iran', 'Iraq', 'Saudi Arabia', 'Turkey','Israel', 'Kuwait','Kazakhstan']
MiddleEast3         = ['Qatar',  'Tajikistan', 'Syria', 'Uzbekistan', 'West Bank and Gaza']

Oceania             = ['French Polynesia', 'New Caledonia', 'Australia','Australian Capital Territory', 'New South Wales', 'Northern Territory',
                       'Queensland', 'South Australia', 'Tasmania', 'Victoria', 'Western Australia',
                       'New Zealand']
AmericaUSA             = ['US']

AustralianStates       = ['Australian Capital Territory', 'New South Wales', 'Northern Territory',
                       'Queensland', 'South Australia', 'Tasmania', 'Victoria', 'Western Australia']
Australasia        =  ['New Zealand', 'Australian Capital Territory', 'New South Wales', 'Northern Territory',
                       'Queensland', 'South Australia', 'Tasmania', 'Victoria', 'Western Australia']

noVictoria        =  ['New Zealand', 'Australian Capital Territory', 'New South Wales', 'Northern Territory',
                       'Queensland', 'South Australia', 'Tasmania', 'Western Australia']


 
#Figures now render in the Plots pane by default. 
#To make them also appear inline in the Console, uncheck 
#"Mute Inline Plotting" under the Plots pane options menu. 
"""
"""
graphCountries (AfricaNorthern1,        'Northern Africa 1of2', nrFigureCols = 3, directToFile=True)

graphCountries (AfricaNorthern2,        'Northern Africa 2of2',          directToFile=True)
graphCountries (AfricaCentral1,          'Central Africa 1of2',           directToFile=True)
graphCountries (AfricaCentral2,          'Central Africa 2of2',           directToFile=True)
graphCountries (AfricaWest,             'West Africa',              directToFile=True)
graphCountries (AfricaEastern,          'Eastern Africa',           directToFile=True)
graphCountries (AfricaSouthern1,         'Southern Africa (no South Africa)',          directToFile=True)
graphCountries (AfricaSouthern2,         'Southern Africa: South Africa',          directToFile=True)

graphCountries (AmericaCentral1,        'Central America 1of2 (Brazil & Mexico)', directToFile=True)
graphCountries (AmericaCentral2,        'Central America 2of2',        directToFile=True)

graphCountries (AmericaUSA,                    'United States',            directToFile=True)

graphCountries (AsiaNoChina,            'Asia-no China',       directToFile=True)
graphCountries (AsiaSouth1,             'South Asia 1of2',               directToFile=True)
graphCountries (AsiaSouth2,             'South Asia 2of2',               directToFile=True)
graphCountries (AsiaSouth3,             'South Asia 2of2',               directToFile=True)
graphCountries (AsiaSouthEast,          'South-East Asia',           directToFile=True)

graphCountries (Australasia,            'Australasian Territories', directToFile=True)
graphCountries (Canada1,                'Canadian Provinces-no Ontario or Quebec', directToFile=True)
graphCountries (Canada2,                'Canada: Ontario & Quebec', directToFile=True)

graphCountries (ChineseProvinces1,       'Chinese Provinces 1 of 4',   directToFile=True)
graphCountries (ChineseProvinces2,       'Chinese Provinces 2 of 4',        directToFile=True)
graphCountries (ChineseProvinces3,       'Chinese Provinces 3 of 4',        directToFile=True)
graphCountries (ChineseProvinces4,       'Chinese Provinces 4 of 4',        directToFile=True)

graphCountries (Carribean1,              'Carribean 1 of 3',        nrFigureCols = 2, directToFile=True)
graphCountries (Carribean2,              'Carribean 2 of 3',        nrFigureCols = 2, directToFile=True)
graphCountries (Carribean3,              'Carribean 3 of 3 (All)',  nrFigureCols = 2, directToFile=True)

#graphCountries (EuropeNorthWestern1,     'North-Western Europe',     directToFile=True)
graphCountries (EuropeNorthWestern2,     'North-Western Europe (no Sweden)',     directToFile=True)
graphCountries (EuropeNorthWestern3,     'North-Western Europe: Sweden)',     directToFile=True)
graphCountries (EuropeNorthEastern,     'North-Eastern Europe',     directToFile=True)
graphCountries (EuropeCentralEastern1,   'Central-Eastern Europe 1 of 1',   directToFile=True)

graphCountries (EuropeSouthWestern1,     'South-Western Europe 1 of 2', nrFigureCols = 1, directToFile=True)
graphCountries (EuropeSouthWestern2,     'South-Western Europe 2 of 2', directToFile=True)
graphCountries (EuropeSouthWestern3,     'South-Western Europe 2 of 2', directToFile=True)
graphCountries (EuropeSouthEastern,     'South-Eastern Europe',     directToFile=True)

graphCountries (MiddleEast1,            'Middle East (1 of 3)',        directToFile=True)
graphCountries (MiddleEast2,            'Middle East (2 of 3)',        directToFile=True)
graphCountries (MiddleEast3,            'Middle East (3 of 3)',        directToFile=True)
#graphCountries (Asia,                   'Asia',                     directToFile=True)
graphCountries (Oceania,                'Oceania',                  directToFile=True)

#graphCountries (NorthAmerica, 'North America', directToFile=True)
#graphCountries (AustralianStates,       'Australian States',        directToFile=True)
#graphCountries (noVictoria,             'Australia (no Victoria)',  directToFile=True)




"""
allSoFar=NorthWesternEurope +NorthEasternEurope +CentralEasternEurope +SouthWesternEurope
allSoFar2 =SouthEasternEurope +SouthAsia +NorthernAfrica +CentralAfrica +SouthernAfrica
allSoFar3 = Asia +SouthAsia +SouthEastAsia + MiddleEast
allSoFar += allSoFar2 +allSoFar3
allSoFar.sort()
print (len (allSoFar))
# identity check
#for province in provinceDeathsDict.keys():
#    if province not in allSoFar :
#        print (province)

#directory="/volumes/DRWORANGE32/COVID-19/dataSets/"
#aussie = CountryDeaths('Australia')#
#graphCountries (Australasia , 'Aussie')
#graphCountries(NorthWesternEurope, 'North-Western Europe')
notYetClassified = []

#  ============== Get Extract Regional Data ===================================
fname= "WorldRegionsUpdated.csv"

with open(directory+fname, newline='') as csvfile:
    ipdata = csv.reader(csvfile, delimiter=',', quotechar='"')
    for row in ipdata:
#        print (row[0])
        if row [0] in notYetClassified:
            print (row[:2])  # get the region

# "us-counties20200516.csv"






from datetime import datetime

for datey in range (DateBeginCol, len(deathsDB[colLabelRow])):
    deathsDB[colLabelRow][datey] = datetime.strptime(deathsDB[colLabelRow][datey], "%m/%d/%y").date()
#    print (deathsDB[colLabelRow][datey])

for datey in range (DateBeginCol, len(deathsDB[colLabelRow])-7, 4):
    print (deathsDB[colLabelRow][datey+7]- deathsDB[colLabelRow][datey])
    print (deathsDB[colLabelRow][datey])


dateDict={}


countyList = []

dateList = []
for place in deathsDB:
    if place[0] not in dateList:
        dateList += [place[0]]
dateList = dateList[1:]                                     # drop the column title
#print (dateList)
#print ("==========dates\n", dateList)
"""
"""
plt.title("Daily Covid-19 Deaths\nfor the period "+columnLabels[4]+ '–' +columnLabels[-1], fontsize=18)
plt.ylabel("Number of Confirmed Deaths", fontsize=12)
plt.legend(title='Country/Region')
plt.grid(axis='both', which='both', color='grey', linestyle='-', linewidth=0.25)
"""
    # tests of class CountryDeaths()
"""

aust = CountryDeaths("Australia")       #; countriesInConsiderationList += ['aust']
nz=CountryDeaths("New Zealand")
iceland = CountryDeaths("Iceland")
china = CountryDeaths("China")
plt.plot(china.deathIncrements)
plt.plot(china.SMAdata)
china.SMA(3)
plt.plot(china.SMAdata)
brazil =    CountryDeaths('Brazil') ; plt.plot(brazil.deathIncrements,    label='Brazil') # ; brazil.SMA(3) ; plt.plot(brazil.SMAdata)
china =     CountryDeaths('China') ; plt.plot(brazil.deathIncrements,    label='China') # ; brazil.SMA(3) ; plt.plot(brazil.SMAdata)
france =    CountryDeaths('France')  ; plt.plot(france.deathIncrements,     label='France')
india =     CountryDeaths('India')  ; plt.plot(india.deathIncrements,     label='India')
mexico =    CountryDeaths('Mexico') ; plt.plot(mexico.deathIncrements,    label='Mexico')
#pakistan =  CountryDeaths('Pakistan'); plt.plot(pakistan.deathIncrements,  label='Pakistan')
india =     CountryDeaths('India')  ; plt.plot(india.deathIncrements,     label='India')
russia =    CountryDeaths('Russia") ; plt.plot(russia.deathIncrements,    label='Russia')
spain =     CountryDeaths('Spain") ; plt.plot(spain.deathIncrements,    label='Spain")
#sweden =    CountryDeaths("Sweden") ; plt.plot(sweden.deathIncrements,    label='Sweden')
UK =        CountryDeaths('United Kingdom") ; plt.plot(UK.deathIncrements,  label='United Kingdom')
USA =       CountryDeaths('USA')     ; plt.plot(USA.deathIncrements,       label='United States')
"""
